package at.jku.students;
                       
import at.jku.ssw.Sorter;

/** A divide and conquer sorting algorithm. */
public class MergeSort extends Sorter {
  
  /** Sorts the array <code>items</code> of comparable objects. */
  public void sort(Comparable[] data) {
    sort0(data, 0, data.length-1);
  }
  
  private static void sort0(Comparable[] data, int lbound, int ubound) {
    int len = ubound - lbound + 1;
    if(len <= 1) {
      return;
    }
    int mid = (lbound + ubound) / 2;
    sort0(data, lbound, mid);
    sort0(data, mid+1, ubound);
    Comparable[] temp = new Comparable[len];
    int temp_index = 0;
    for (int left = lbound, right = mid+1; left <= mid || right <= ubound; ) {
      if (right > ubound) {
        temp[temp_index++] = data[left++];
      } else if (left > mid) {
        temp[temp_index++] = data[right++];
      } else if (data[left].compareTo(data[right]) <= 0) {
        temp[temp_index++] = data[left++];
      } else {
        temp[temp_index++] = data[right++];
      }
    }
    System.arraycopy(temp, 0, data, lbound, temp.length);
  }

}